# -*- encoding: utf-8 -*-
# stub: activerecord 4.2.6 ruby lib

Gem::Specification.new do |s|
  s.name = "activerecord"
  s.version = "4.2.6"

  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib"]
  s.authors = ["David Heinemeier Hansson"]
  s.date = "2025-02-20"
  s.description = "Databases on Rails. Build a persistent domain model by mapping database tables to Ruby classes. Strong conventions for associations, validations, aggregations, migrations, and testing come baked-in."
  s.email = "david@loudthinking.com"
  s.extra_rdoc_files = ["README.rdoc"]
  s.files = ["CHANGELOG.md", "MIT-LICENSE", "README.rdoc", "examples/performance.rb", "examples/simple.rb", "lib/active_record", "lib/active_record.rb", "lib/active_record/aggregations.rb", "lib/active_record/association_relation.rb", "lib/active_record/associations", "lib/active_record/associations.rb", "lib/active_record/associations/alias_tracker.rb", "lib/active_record/associations/association.rb", "lib/active_record/associations/association_scope.rb", "lib/active_record/associations/belongs_to_association.rb", "lib/active_record/associations/belongs_to_polymorphic_association.rb", "lib/active_record/associations/builder", "lib/active_record/associations/builder/association.rb", "lib/active_record/associations/builder/belongs_to.rb", "lib/active_record/associations/builder/collection_association.rb", "lib/active_record/associations/builder/has_and_belongs_to_many.rb", "lib/active_record/associations/builder/has_many.rb", "lib/active_record/associations/builder/has_one.rb", "lib/active_record/associations/builder/singular_association.rb", "lib/active_record/associations/collection_association.rb", "lib/active_record/associations/collection_proxy.rb", "lib/active_record/associations/foreign_association.rb", "lib/active_record/associations/has_many_association.rb", "lib/active_record/associations/has_many_through_association.rb", "lib/active_record/associations/has_one_association.rb", "lib/active_record/associations/has_one_through_association.rb", "lib/active_record/associations/join_dependency", "lib/active_record/associations/join_dependency.rb", "lib/active_record/associations/join_dependency/join_association.rb", "lib/active_record/associations/join_dependency/join_base.rb", "lib/active_record/associations/join_dependency/join_part.rb", "lib/active_record/associations/preloader", "lib/active_record/associations/preloader.rb", "lib/active_record/associations/preloader/association.rb", "lib/active_record/associations/preloader/belongs_to.rb", "lib/active_record/associations/preloader/collection_association.rb", "lib/active_record/associations/preloader/has_many.rb", "lib/active_record/associations/preloader/has_many_through.rb", "lib/active_record/associations/preloader/has_one.rb", "lib/active_record/associations/preloader/has_one_through.rb", "lib/active_record/associations/preloader/singular_association.rb", "lib/active_record/associations/preloader/through_association.rb", "lib/active_record/associations/singular_association.rb", "lib/active_record/associations/through_association.rb", "lib/active_record/attribute.rb", "lib/active_record/attribute_assignment.rb", "lib/active_record/attribute_decorators.rb", "lib/active_record/attribute_methods", "lib/active_record/attribute_methods.rb", "lib/active_record/attribute_methods/before_type_cast.rb", "lib/active_record/attribute_methods/dirty.rb", "lib/active_record/attribute_methods/primary_key.rb", "lib/active_record/attribute_methods/query.rb", "lib/active_record/attribute_methods/read.rb", "lib/active_record/attribute_methods/serialization.rb", "lib/active_record/attribute_methods/time_zone_conversion.rb", "lib/active_record/attribute_methods/write.rb", "lib/active_record/attribute_set", "lib/active_record/attribute_set.rb", "lib/active_record/attribute_set/builder.rb", "lib/active_record/attributes.rb", "lib/active_record/autosave_association.rb", "lib/active_record/base.rb", "lib/active_record/callbacks.rb", "lib/active_record/coders", "lib/active_record/coders/json.rb", "lib/active_record/coders/yaml_column.rb", "lib/active_record/connection_adapters", "lib/active_record/connection_adapters/abstract", "lib/active_record/connection_adapters/abstract/connection_pool.rb", "lib/active_record/connection_adapters/abstract/database_limits.rb", "lib/active_record/connection_adapters/abstract/database_statements.rb", "lib/active_record/connection_adapters/abstract/query_cache.rb", "lib/active_record/connection_adapters/abstract/quoting.rb", "lib/active_record/connection_adapters/abstract/savepoints.rb", "lib/active_record/connection_adapters/abstract/schema_creation.rb", "lib/active_record/connection_adapters/abstract/schema_definitions.rb", "lib/active_record/connection_adapters/abstract/schema_dumper.rb", "lib/active_record/connection_adapters/abstract/schema_statements.rb", "lib/active_record/connection_adapters/abstract/transaction.rb", "lib/active_record/connection_adapters/abstract_adapter.rb", "lib/active_record/connection_adapters/abstract_mysql_adapter.rb", "lib/active_record/connection_adapters/column.rb", "lib/active_record/connection_adapters/connection_specification.rb", "lib/active_record/connection_adapters/mysql2_adapter.rb", "lib/active_record/connection_adapters/mysql_adapter.rb", "lib/active_record/connection_adapters/postgresql", "lib/active_record/connection_adapters/postgresql/array_parser.rb", "lib/active_record/connection_adapters/postgresql/column.rb", "lib/active_record/connection_adapters/postgresql/database_statements.rb", "lib/active_record/connection_adapters/postgresql/oid", "lib/active_record/connection_adapters/postgresql/oid.rb", "lib/active_record/connection_adapters/postgresql/oid/array.rb", "lib/active_record/connection_adapters/postgresql/oid/bit.rb", "lib/active_record/connection_adapters/postgresql/oid/bit_varying.rb", "lib/active_record/connection_adapters/postgresql/oid/bytea.rb", "lib/active_record/connection_adapters/postgresql/oid/cidr.rb", "lib/active_record/connection_adapters/postgresql/oid/date.rb", "lib/active_record/connection_adapters/postgresql/oid/date_time.rb", "lib/active_record/connection_adapters/postgresql/oid/decimal.rb", "lib/active_record/connection_adapters/postgresql/oid/enum.rb", "lib/active_record/connection_adapters/postgresql/oid/float.rb", "lib/active_record/connection_adapters/postgresql/oid/hstore.rb", "lib/active_record/connection_adapters/postgresql/oid/inet.rb", "lib/active_record/connection_adapters/postgresql/oid/infinity.rb", "lib/active_record/connection_adapters/postgresql/oid/integer.rb", "lib/active_record/connection_adapters/postgresql/oid/json.rb", "lib/active_record/connection_adapters/postgresql/oid/jsonb.rb", "lib/active_record/connection_adapters/postgresql/oid/money.rb", "lib/active_record/connection_adapters/postgresql/oid/point.rb", "lib/active_record/connection_adapters/postgresql/oid/range.rb", "lib/active_record/connection_adapters/postgresql/oid/specialized_string.rb", "lib/active_record/connection_adapters/postgresql/oid/time.rb", "lib/active_record/connection_adapters/postgresql/oid/type_map_initializer.rb", "lib/active_record/connection_adapters/postgresql/oid/uuid.rb", "lib/active_record/connection_adapters/postgresql/oid/vector.rb", "lib/active_record/connection_adapters/postgresql/oid/xml.rb", "lib/active_record/connection_adapters/postgresql/quoting.rb", "lib/active_record/connection_adapters/postgresql/referential_integrity.rb", "lib/active_record/connection_adapters/postgresql/schema_definitions.rb", "lib/active_record/connection_adapters/postgresql/schema_statements.rb", "lib/active_record/connection_adapters/postgresql/utils.rb", "lib/active_record/connection_adapters/postgresql_adapter.rb", "lib/active_record/connection_adapters/schema_cache.rb", "lib/active_record/connection_adapters/sqlite3_adapter.rb", "lib/active_record/connection_adapters/statement_pool.rb", "lib/active_record/connection_handling.rb", "lib/active_record/core.rb", "lib/active_record/counter_cache.rb", "lib/active_record/dynamic_matchers.rb", "lib/active_record/enum.rb", "lib/active_record/errors.rb", "lib/active_record/explain.rb", "lib/active_record/explain_registry.rb", "lib/active_record/explain_subscriber.rb", "lib/active_record/fixture_set", "lib/active_record/fixture_set/file.rb", "lib/active_record/fixtures.rb", "lib/active_record/gem_version.rb", "lib/active_record/inheritance.rb", "lib/active_record/integration.rb", "lib/active_record/legacy_yaml_adapter.rb", "lib/active_record/locale", "lib/active_record/locale/en.yml", "lib/active_record/locking", "lib/active_record/locking/optimistic.rb", "lib/active_record/locking/pessimistic.rb", "lib/active_record/log_subscriber.rb", "lib/active_record/migration", "lib/active_record/migration.rb", "lib/active_record/migration/command_recorder.rb", "lib/active_record/migration/join_table.rb", "lib/active_record/model_schema.rb", "lib/active_record/nested_attributes.rb", "lib/active_record/no_touching.rb", "lib/active_record/null_relation.rb", "lib/active_record/persistence.rb", "lib/active_record/query_cache.rb", "lib/active_record/querying.rb", "lib/active_record/railtie.rb", "lib/active_record/railties", "lib/active_record/railties/console_sandbox.rb", "lib/active_record/railties/controller_runtime.rb", "lib/active_record/railties/databases.rake", "lib/active_record/railties/jdbcmysql_error.rb", "lib/active_record/readonly_attributes.rb", "lib/active_record/reflection.rb", "lib/active_record/relation", "lib/active_record/relation.rb", "lib/active_record/relation/batches.rb", "lib/active_record/relation/calculations.rb", "lib/active_record/relation/delegation.rb", "lib/active_record/relation/finder_methods.rb", "lib/active_record/relation/merger.rb", "lib/active_record/relation/predicate_builder", "lib/active_record/relation/predicate_builder.rb", "lib/active_record/relation/predicate_builder/array_handler.rb", "lib/active_record/relation/predicate_builder/relation_handler.rb", "lib/active_record/relation/query_methods.rb", "lib/active_record/relation/spawn_methods.rb", "lib/active_record/result.rb", "lib/active_record/runtime_registry.rb", "lib/active_record/sanitization.rb", "lib/active_record/schema.rb", "lib/active_record/schema_dumper.rb", "lib/active_record/schema_migration.rb", "lib/active_record/scoping", "lib/active_record/scoping.rb", "lib/active_record/scoping/default.rb", "lib/active_record/scoping/named.rb", "lib/active_record/serialization.rb", "lib/active_record/serializers", "lib/active_record/serializers/xml_serializer.rb", "lib/active_record/statement_cache.rb", "lib/active_record/store.rb", "lib/active_record/tasks", "lib/active_record/tasks/database_tasks.rb", "lib/active_record/tasks/mysql_database_tasks.rb", "lib/active_record/tasks/postgresql_database_tasks.rb", "lib/active_record/tasks/sqlite_database_tasks.rb", "lib/active_record/timestamp.rb", "lib/active_record/transactions.rb", "lib/active_record/translation.rb", "lib/active_record/type", "lib/active_record/type.rb", "lib/active_record/type/big_integer.rb", "lib/active_record/type/binary.rb", "lib/active_record/type/boolean.rb", "lib/active_record/type/date.rb", "lib/active_record/type/date_time.rb", "lib/active_record/type/decimal.rb", "lib/active_record/type/decimal_without_scale.rb", "lib/active_record/type/decorator.rb", "lib/active_record/type/float.rb", "lib/active_record/type/hash_lookup_type_map.rb", "lib/active_record/type/integer.rb", "lib/active_record/type/mutable.rb", "lib/active_record/type/numeric.rb", "lib/active_record/type/serialized.rb", "lib/active_record/type/string.rb", "lib/active_record/type/text.rb", "lib/active_record/type/time.rb", "lib/active_record/type/time_value.rb", "lib/active_record/type/type_map.rb", "lib/active_record/type/unsigned_integer.rb", "lib/active_record/type/value.rb", "lib/active_record/validations", "lib/active_record/validations.rb", "lib/active_record/validations/associated.rb", "lib/active_record/validations/presence.rb", "lib/active_record/validations/uniqueness.rb", "lib/active_record/version.rb", "lib/rails", "lib/rails/generators", "lib/rails/generators/active_record", "lib/rails/generators/active_record.rb", "lib/rails/generators/active_record/migration", "lib/rails/generators/active_record/migration.rb", "lib/rails/generators/active_record/migration/migration_generator.rb", "lib/rails/generators/active_record/migration/templates", "lib/rails/generators/active_record/migration/templates/create_table_migration.rb", "lib/rails/generators/active_record/migration/templates/migration.rb", "lib/rails/generators/active_record/model", "lib/rails/generators/active_record/model/model_generator.rb", "lib/rails/generators/active_record/model/templates", "lib/rails/generators/active_record/model/templates/model.rb", "lib/rails/generators/active_record/model/templates/module.rb"]
  s.homepage = "http://www.rubyonrails.org"
  s.licenses = ["MIT"]
  s.rdoc_options = ["--main", "README.rdoc"]
  s.required_ruby_version = Gem::Requirement.new(">= 1.9.3")
  s.rubygems_version = "2.5.2.1"
  s.summary = "Object-relational mapper framework (part of Rails)."

  if s.respond_to? :specification_version then
    s.specification_version = 4

    if Gem::Version.new(Gem::VERSION) >= Gem::Version.new('1.2.0') then
      s.add_runtime_dependency(%q<activesupport>, ["= 4.2.6"])
      s.add_runtime_dependency(%q<activemodel>, ["= 4.2.6"])
      s.add_runtime_dependency(%q<arel>, ["~> 6.0"])
    else
      s.add_dependency(%q<activesupport>, ["= 4.2.6"])
      s.add_dependency(%q<activemodel>, ["= 4.2.6"])
      s.add_dependency(%q<arel>, ["~> 6.0"])
    end
  else
    s.add_dependency(%q<activesupport>, ["= 4.2.6"])
    s.add_dependency(%q<activemodel>, ["= 4.2.6"])
    s.add_dependency(%q<arel>, ["~> 6.0"])
  end
end
